// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"
	"time"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/definition"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/predicate"
	"gitlab.com/oscar.alberto.tovar/wdym/ent/term"
)

// TermUpdate is the builder for updating Term entities.
type TermUpdate struct {
	config
	hooks     []Hook
	mutation  *TermMutation
	modifiers []func(*sql.UpdateBuilder)
}

// Where appends a list predicates to the TermUpdate builder.
func (tu *TermUpdate) Where(ps ...predicate.Term) *TermUpdate {
	tu.mutation.Where(ps...)
	return tu
}

// SetUpdatedAt sets the "updated_at" field.
func (tu *TermUpdate) SetUpdatedAt(t time.Time) *TermUpdate {
	tu.mutation.SetUpdatedAt(t)
	return tu
}

// SetText sets the "text" field.
func (tu *TermUpdate) SetText(s string) *TermUpdate {
	tu.mutation.SetText(s)
	return tu
}

// AddDefinitionIDs adds the "definitions" edge to the Definition entity by IDs.
func (tu *TermUpdate) AddDefinitionIDs(ids ...int) *TermUpdate {
	tu.mutation.AddDefinitionIDs(ids...)
	return tu
}

// AddDefinitions adds the "definitions" edges to the Definition entity.
func (tu *TermUpdate) AddDefinitions(d ...*Definition) *TermUpdate {
	ids := make([]int, len(d))
	for i := range d {
		ids[i] = d[i].ID
	}
	return tu.AddDefinitionIDs(ids...)
}

// Mutation returns the TermMutation object of the builder.
func (tu *TermUpdate) Mutation() *TermMutation {
	return tu.mutation
}

// ClearDefinitions clears all "definitions" edges to the Definition entity.
func (tu *TermUpdate) ClearDefinitions() *TermUpdate {
	tu.mutation.ClearDefinitions()
	return tu
}

// RemoveDefinitionIDs removes the "definitions" edge to Definition entities by IDs.
func (tu *TermUpdate) RemoveDefinitionIDs(ids ...int) *TermUpdate {
	tu.mutation.RemoveDefinitionIDs(ids...)
	return tu
}

// RemoveDefinitions removes "definitions" edges to Definition entities.
func (tu *TermUpdate) RemoveDefinitions(d ...*Definition) *TermUpdate {
	ids := make([]int, len(d))
	for i := range d {
		ids[i] = d[i].ID
	}
	return tu.RemoveDefinitionIDs(ids...)
}

// Save executes the query and returns the number of nodes affected by the update operation.
func (tu *TermUpdate) Save(ctx context.Context) (int, error) {
	tu.defaults()
	return withHooks(ctx, tu.sqlSave, tu.mutation, tu.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (tu *TermUpdate) SaveX(ctx context.Context) int {
	affected, err := tu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (tu *TermUpdate) Exec(ctx context.Context) error {
	_, err := tu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tu *TermUpdate) ExecX(ctx context.Context) {
	if err := tu.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (tu *TermUpdate) defaults() {
	if _, ok := tu.mutation.UpdatedAt(); !ok {
		v := term.UpdateDefaultUpdatedAt()
		tu.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (tu *TermUpdate) check() error {
	if v, ok := tu.mutation.Text(); ok {
		if err := term.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Term.text": %w`, err)}
		}
	}
	return nil
}

// Modify adds a statement modifier for attaching custom logic to the UPDATE statement.
func (tu *TermUpdate) Modify(modifiers ...func(u *sql.UpdateBuilder)) *TermUpdate {
	tu.modifiers = append(tu.modifiers, modifiers...)
	return tu
}

func (tu *TermUpdate) sqlSave(ctx context.Context) (n int, err error) {
	if err := tu.check(); err != nil {
		return n, err
	}
	_spec := sqlgraph.NewUpdateSpec(term.Table, term.Columns, sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt))
	if ps := tu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := tu.mutation.UpdatedAt(); ok {
		_spec.SetField(term.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := tu.mutation.Text(); ok {
		_spec.SetField(term.FieldText, field.TypeString, value)
	}
	if tu.mutation.DefinitionsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   term.DefinitionsTable,
			Columns: []string{term.DefinitionsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := tu.mutation.RemovedDefinitionsIDs(); len(nodes) > 0 && !tu.mutation.DefinitionsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   term.DefinitionsTable,
			Columns: []string{term.DefinitionsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := tu.mutation.DefinitionsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   term.DefinitionsTable,
			Columns: []string{term.DefinitionsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_spec.AddModifiers(tu.modifiers...)
	if n, err = sqlgraph.UpdateNodes(ctx, tu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{term.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return 0, err
	}
	tu.mutation.done = true
	return n, nil
}

// TermUpdateOne is the builder for updating a single Term entity.
type TermUpdateOne struct {
	config
	fields    []string
	hooks     []Hook
	mutation  *TermMutation
	modifiers []func(*sql.UpdateBuilder)
}

// SetUpdatedAt sets the "updated_at" field.
func (tuo *TermUpdateOne) SetUpdatedAt(t time.Time) *TermUpdateOne {
	tuo.mutation.SetUpdatedAt(t)
	return tuo
}

// SetText sets the "text" field.
func (tuo *TermUpdateOne) SetText(s string) *TermUpdateOne {
	tuo.mutation.SetText(s)
	return tuo
}

// AddDefinitionIDs adds the "definitions" edge to the Definition entity by IDs.
func (tuo *TermUpdateOne) AddDefinitionIDs(ids ...int) *TermUpdateOne {
	tuo.mutation.AddDefinitionIDs(ids...)
	return tuo
}

// AddDefinitions adds the "definitions" edges to the Definition entity.
func (tuo *TermUpdateOne) AddDefinitions(d ...*Definition) *TermUpdateOne {
	ids := make([]int, len(d))
	for i := range d {
		ids[i] = d[i].ID
	}
	return tuo.AddDefinitionIDs(ids...)
}

// Mutation returns the TermMutation object of the builder.
func (tuo *TermUpdateOne) Mutation() *TermMutation {
	return tuo.mutation
}

// ClearDefinitions clears all "definitions" edges to the Definition entity.
func (tuo *TermUpdateOne) ClearDefinitions() *TermUpdateOne {
	tuo.mutation.ClearDefinitions()
	return tuo
}

// RemoveDefinitionIDs removes the "definitions" edge to Definition entities by IDs.
func (tuo *TermUpdateOne) RemoveDefinitionIDs(ids ...int) *TermUpdateOne {
	tuo.mutation.RemoveDefinitionIDs(ids...)
	return tuo
}

// RemoveDefinitions removes "definitions" edges to Definition entities.
func (tuo *TermUpdateOne) RemoveDefinitions(d ...*Definition) *TermUpdateOne {
	ids := make([]int, len(d))
	for i := range d {
		ids[i] = d[i].ID
	}
	return tuo.RemoveDefinitionIDs(ids...)
}

// Where appends a list predicates to the TermUpdate builder.
func (tuo *TermUpdateOne) Where(ps ...predicate.Term) *TermUpdateOne {
	tuo.mutation.Where(ps...)
	return tuo
}

// Select allows selecting one or more fields (columns) of the returned entity.
// The default is selecting all fields defined in the entity schema.
func (tuo *TermUpdateOne) Select(field string, fields ...string) *TermUpdateOne {
	tuo.fields = append([]string{field}, fields...)
	return tuo
}

// Save executes the query and returns the updated Term entity.
func (tuo *TermUpdateOne) Save(ctx context.Context) (*Term, error) {
	tuo.defaults()
	return withHooks(ctx, tuo.sqlSave, tuo.mutation, tuo.hooks)
}

// SaveX is like Save, but panics if an error occurs.
func (tuo *TermUpdateOne) SaveX(ctx context.Context) *Term {
	node, err := tuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (tuo *TermUpdateOne) Exec(ctx context.Context) error {
	_, err := tuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (tuo *TermUpdateOne) ExecX(ctx context.Context) {
	if err := tuo.Exec(ctx); err != nil {
		panic(err)
	}
}

// defaults sets the default values of the builder before save.
func (tuo *TermUpdateOne) defaults() {
	if _, ok := tuo.mutation.UpdatedAt(); !ok {
		v := term.UpdateDefaultUpdatedAt()
		tuo.mutation.SetUpdatedAt(v)
	}
}

// check runs all checks and user-defined validators on the builder.
func (tuo *TermUpdateOne) check() error {
	if v, ok := tuo.mutation.Text(); ok {
		if err := term.TextValidator(v); err != nil {
			return &ValidationError{Name: "text", err: fmt.Errorf(`ent: validator failed for field "Term.text": %w`, err)}
		}
	}
	return nil
}

// Modify adds a statement modifier for attaching custom logic to the UPDATE statement.
func (tuo *TermUpdateOne) Modify(modifiers ...func(u *sql.UpdateBuilder)) *TermUpdateOne {
	tuo.modifiers = append(tuo.modifiers, modifiers...)
	return tuo
}

func (tuo *TermUpdateOne) sqlSave(ctx context.Context) (_node *Term, err error) {
	if err := tuo.check(); err != nil {
		return _node, err
	}
	_spec := sqlgraph.NewUpdateSpec(term.Table, term.Columns, sqlgraph.NewFieldSpec(term.FieldID, field.TypeInt))
	id, ok := tuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "id", err: errors.New(`ent: missing "Term.id" for update`)}
	}
	_spec.Node.ID.Value = id
	if fields := tuo.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, term.FieldID)
		for _, f := range fields {
			if !term.ValidColumn(f) {
				return nil, &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
			}
			if f != term.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, f)
			}
		}
	}
	if ps := tuo.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := tuo.mutation.UpdatedAt(); ok {
		_spec.SetField(term.FieldUpdatedAt, field.TypeTime, value)
	}
	if value, ok := tuo.mutation.Text(); ok {
		_spec.SetField(term.FieldText, field.TypeString, value)
	}
	if tuo.mutation.DefinitionsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   term.DefinitionsTable,
			Columns: []string{term.DefinitionsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt),
			},
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := tuo.mutation.RemovedDefinitionsIDs(); len(nodes) > 0 && !tuo.mutation.DefinitionsCleared() {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   term.DefinitionsTable,
			Columns: []string{term.DefinitionsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Clear = append(_spec.Edges.Clear, edge)
	}
	if nodes := tuo.mutation.DefinitionsIDs(); len(nodes) > 0 {
		edge := &sqlgraph.EdgeSpec{
			Rel:     sqlgraph.O2M,
			Inverse: false,
			Table:   term.DefinitionsTable,
			Columns: []string{term.DefinitionsColumn},
			Bidi:    false,
			Target: &sqlgraph.EdgeTarget{
				IDSpec: sqlgraph.NewFieldSpec(definition.FieldID, field.TypeInt),
			},
		}
		for _, k := range nodes {
			edge.Target.Nodes = append(edge.Target.Nodes, k)
		}
		_spec.Edges.Add = append(_spec.Edges.Add, edge)
	}
	_spec.AddModifiers(tuo.modifiers...)
	_node = &Term{config: tuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues
	if err = sqlgraph.UpdateNode(ctx, tuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{term.Label}
		} else if sqlgraph.IsConstraintError(err) {
			err = &ConstraintError{msg: err.Error(), wrap: err}
		}
		return nil, err
	}
	tuo.mutation.done = true
	return _node, nil
}
